//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2
#property indicator_level1  0.7
#property indicator_level2 -0.7
#property indicator_minimum -1
#property indicator_maximum  1

//
//
//
//
//

extern string TimeFrame = "current time frame";
extern int SMAfast   =  5;
extern int SMAslow   = 55;

double TrendBuffer[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,TrendBuffer);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   IndicatorShortName(timeFrameToString(timeFrame)+" TrendPower("+SMAfast+")");
   return(0);
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { TrendBuffer[0] = MathMin(limit+1,Bars-1); return(0); }
         if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //  
 
   for(int i = limit; i>=0 ; i--)
	{
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double maf = iMA(NULL,timeFrame,SMAfast,0,MODE_EMA,PRICE_CLOSE,y);
      double mas = iMA(NULL,timeFrame,SMAslow,0,MODE_EMA,PRICE_CLOSE,y);
      double atf = iATR(NULL,timeFrame,SMAfast,y);
      double ats = iATR(NULL,timeFrame,SMAslow,y);
      if (ats!=0)
	        double MAValue = 100.0*(maf-mas)*atf/mas/ats;
      else        MAValue = 0; 
	   TrendBuffer[i]=(MathExp(2*MAValue)-1)/(MathExp(2*MAValue)+1);
   }
	return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}